=== debian/changelog ===
mlt (7.34.0-1) unstable; urgency=medium

  * New upstream release.
    - FFmpeg 8 support has been added.
      Closes: #1115055
    - SDL 1.2 support is disabled by default now. We try to drop it now, too.
      Closes: #1038506
  * Adjust lintian overrides.
  * Fix old-fsf-address-in-copyright-file lintian warning.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 04 Nov 2025 22:36:47 +0100
