=== debian/watch ===
version=4
opts=dversionmangle=s/\+git\d+//;s/\+repack\d// \
https://github.com/mltframework/mlt/tags .*/v(\d\S+)\.tar\.gz
